Holger's Java API

## com.antelmann.math
Class JDataMatrixView

    java.lang.Object
      java.awt.Component
          java.awt.Container
              javax.swing.JComponent
                  com.antelmann.math.JDataMatrixView

All Implemented Interfaces:
  EditableComponent, ValueRetriever<DataMatrix<?>>, ImageObserver, MenuContainer, Serializable

    public class JDataMatrixView

extends JComponent
implements ValueRetriever<DataMatrix<?>>, EditableComponent

allows the multidimensional visualization of a `DataMatrix` instance

Since:
  08.10.2010, 14:00:18
Author:
  Holger Antelmann
See Also:
  Serialized Form

Nested Class Summary
`static class` `JDataMatrixView.Cell` used as the table cell value within the embedding component

Nested classes/interfaces inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Nested classes/interfaces inherited from class java.awt.Container
`Container.AccessibleAWTContainer`

Nested classes/interfaces inherited from class java.awt.Component
`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

Field Summary

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`JDataMatrixView(DataMatrix<?> matrix, DataPoint.ValueType type, String... axisNames)`
`JDataMatrixView(DataMatrix<?> matrix, DataPoint.ValueType type, TableCellRenderer renderer, String... axisNames)`
`JDataMatrixView(DataMatrix<?> matrix, DataPoint.ValueType type, TableCellRenderer renderer, TableCellEditor editor, LayoutOption layoutOption, String... axisNames)`
`JDataMatrixView(DataMatrix<?> matrix, DataPoint.ValueType type, TableCellRenderer renderer, TableCellEditor editor, String... axisNames)`

Method Summary
`boolean` `addChangeListener(ChangeListener listener)` the listener's `ChangeEvent` will have the changed `JDataMatrixView.Cell` as the source
`void` `editCellValue(JDataMatrixView.Cell cell)`
`Handler<JDataMatrixView.Cell,?>` `getCellEditValueHandler()`
`ChangeListener[]` `getChangeListeners()`
`TableCellEditor` `getEditor()`
`LayoutOption` `getLayoutOption()`
`DataMatrix<?>` `getMatrix()`
`String` `getNaValue()`
`static TableCellRenderer` `getPercentRenderer(JDataMatrixView view)`
`DataMatrix<?>` `getRelevantValue()` returns the relevant value for this instance at the time of calling
`TableCellRenderer` `getRenderer()`
`JLabel` `getStatusLabel()`
`Handler<JTable,? extends RuntimeException>` `getTableHandler()`
`boolean` `isEditable()` this component is non-editable by default
`protected void` `layoutTable(JTable table)`
`void` `redraw()`
`boolean` `removeChangeListener(ChangeListener listener)`
`void` `setCellEditValueHandler(Handler<JDataMatrixView.Cell,?> handler)`
`void` `setEditable(boolean editable)`
`void` `setEditor(TableCellEditor editor)` note that the given editor should be able to deal with `JDataMatrixView.Cell` objects
`void` `setLayoutOption(LayoutOption layoutOption)`
`void` `setRenderer(TableCellRenderer renderer)`
`void` `setTableHandler(Handler<JTable,? extends RuntimeException> tableHandler)`
`void` `setVisiblePath(List<?> path)`

Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getAccessibleContext, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getUIClassID, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, paramString, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update, updateUI`

Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusBackward, transferFocusDownCycle, validate, validateTree`

Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### JDataMatrixView

    public JDataMatrixView(DataMatrix<?> matrix,
                           DataPoint.ValueType type,
                           String... axisNames)

### JDataMatrixView

    public JDataMatrixView(DataMatrix<?> matrix,
                           DataPoint.ValueType type,
                           TableCellRenderer renderer,
                           String... axisNames)

### JDataMatrixView

    public JDataMatrixView(DataMatrix<?> matrix,
                           DataPoint.ValueType type,
                           TableCellRenderer renderer,
                           TableCellEditor editor,
                           String... axisNames)

### JDataMatrixView

    public JDataMatrixView(DataMatrix<?> matrix,
                           DataPoint.ValueType type,
                           TableCellRenderer renderer,
                           TableCellEditor editor,
                           LayoutOption layoutOption,
                           String... axisNames)

Method Detail

### getStatusLabel

    public JLabel getStatusLabel()

### getNaValue

    public String getNaValue()

### getMatrix

    public DataMatrix<?> getMatrix()

### getRelevantValue

    public DataMatrix<?> getRelevantValue()
                                   throws IOException

  Description copied from interface: `ValueRetriever`
  returns the relevant value for this instance at the time of calling

  Specified by:
    `getRelevantValue` in interface `ValueRetriever<DataMatrix<?>>`
  Throws:
    `IOException` - if any resource to fulfill the request is not accessible

### getRenderer

    public TableCellRenderer getRenderer()

### setRenderer

    public void setRenderer(TableCellRenderer renderer)

### getLayoutOption

    public LayoutOption getLayoutOption()

### setLayoutOption

    public void setLayoutOption(LayoutOption layoutOption)

### isEditable

    public final boolean isEditable()

  this component is non-editable by default

  Specified by:
    `isEditable` in interface `EditableComponent`
  See Also:
    `setEditable(boolean)`

### setEditable

    public void setEditable(boolean editable)

  Specified by:
    `setEditable` in interface `EditableComponent`

### getCellEditValueHandler

    public Handler<JDataMatrixView.Cell,?> getCellEditValueHandler()

### setCellEditValueHandler

    public void setCellEditValueHandler(Handler<JDataMatrixView.Cell,?> handler)

### getEditor

    public TableCellEditor getEditor()

### setEditor

    public void setEditor(TableCellEditor editor)

  note that the given editor should be able to deal with `JDataMatrixView.Cell` objects

### setVisiblePath

    public void setVisiblePath(List<?> path)
                        throws IllegalArgumentException

  Throws:
    `IllegalArgumentException`

### redraw

    @Warning(value="be aware when overriding: this is called by the constructor")
    public void redraw()

### editCellValue

    public void editCellValue(JDataMatrixView.Cell cell)

### getTableHandler

    public Handler<JTable,? extends RuntimeException> getTableHandler()

### setTableHandler

    public void setTableHandler(Handler<JTable,? extends RuntimeException> tableHandler)

### getChangeListeners

    public ChangeListener[] getChangeListeners()

### addChangeListener

    public boolean addChangeListener(ChangeListener listener)

  the listener's `ChangeEvent` will have the changed `JDataMatrixView.Cell` as the source

### removeChangeListener

    public boolean removeChangeListener(ChangeListener listener)

### layoutTable

    protected void layoutTable(JTable table)

### getPercentRenderer

    public static TableCellRenderer getPercentRenderer(JDataMatrixView view)

(c) Holger Antelmann since 2001- all rights reserved (contact: info@antelmann.com)
see www.antelmann.com/developer for further details and available downloads